<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - coverage.info - proyecto/interpolator.vhd</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">proyecto</a> - interpolator.vhd<span style="font-size: 80%;"> (source / <a href="interpolator.vhd.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">23</td>
            <td class="headerCovTableEntry">31</td>
            <td class="headerCovTableEntryLo">74.2 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2023-02-09 17:19:34</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">12</td>
            <td class="headerCovTableEntry">12</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span><span class="lineCov">          6 : -- Linearly nterpolates between inf and sup, outputting 12 intermediate values</span></a>
<a name="2"><span class="lineNum">       2 </span>            : library ieee;</a>
<a name="3"><span class="lineNum">       3 </span>            : use ieee.std_logic_1164.all;</a>
<a name="4"><span class="lineNum">       4 </span>            : use ieee.numeric_std.all;</a>
<a name="5"><span class="lineNum">       5 </span>            : </a>
<a name="6"><span class="lineNum">       6 </span>            : library src_lib;</a>
<a name="7"><span class="lineNum">       7 </span>            : use src_lib.edc_common.all;</a>
<a name="8"><span class="lineNum">       8 </span>            : </a>
<a name="9"><span class="lineNum">       9 </span><span class="lineCov">        136 : entity interpolator is</span></a>
<a name="10"><span class="lineNum">      10 </span>            :         port (</a>
<a name="11"><span class="lineNum">      11 </span>            :             clk : in std_logic;          -- Input clock, active on rising edge</a>
<a name="12"><span class="lineNum">      12 </span>            :             rst : in std_logic;          -- Asynchronous reset, active high</a>
<a name="13"><span class="lineNum">      13 </span>            :             inf : in complex10;          -- Low input</a>
<a name="14"><span class="lineNum">      14 </span>            :             sup : in complex10;          -- High input</a>
<a name="15"><span class="lineNum">      15 </span>            :             valid : in std_logic;        -- When ``'1'``, signals the interpolator to begin interpolating between ``inf`` and ``sup``</a>
<a name="16"><span class="lineNum">      16 </span>            :             estim : out complex10;       -- Interpolated output. Has a 12/16 scale factor, since it estimates 12 times the channel and discards 4 LSB</a>
<a name="17"><span class="lineNum">      17 </span>            :             estim_valid : out std_logic  -- Takes the value ``'1'`` when ``estim`` is valid</a>
<a name="18"><span class="lineNum">      18 </span>            :         );</a>
<a name="19"><span class="lineNum">      19 </span>            :     end interpolator;</a>
<a name="20"><span class="lineNum">      20 </span>            : </a>
<a name="21"><span class="lineNum">      21 </span>            : architecture two_processes of interpolator is</a>
<a name="22"><span class="lineNum">      22 </span>            : </a>
<a name="23"><span class="lineNum">      23 </span><span class="lineCov">         22 :     signal i, p_i    : signed (4 downto 0);  -- Current interpolation stage</span></a>
<a name="24"><span class="lineNum">      24 </span><span class="lineCov">         62 :     signal estim_aux : complex15;            -- Result of the interpolation, before discarding the LSB</span></a>
<a name="25"><span class="lineNum">      25 </span>            : </a>
<a name="26"><span class="lineNum">      26 </span>            :     -- Two signals needed for the firewall assertions</a>
<a name="27"><span class="lineNum">      27 </span><span class="lineCov">         84 :     signal firewall_inf, firewall_sup : complex10;</span></a>
<a name="28"><span class="lineNum">      28 </span>            : </a>
<a name="29"><span class="lineNum">      29 </span>            : begin</a>
<a name="30"><span class="lineNum">      30 </span>            : </a>
<a name="31"><span class="lineNum">      31 </span><span class="lineCov">         12 :     sinc: process(rst, clk)</span></a>
<a name="32"><span class="lineNum">      32 </span>            :     begin</a>
<a name="33"><span class="lineNum">      33 </span><span class="lineCov">          6 :         if rst = '1' then</span></a>
<a name="34"><span class="lineNum">      34 </span><span class="lineNoCov">          0 :             i &lt;= to_signed(12,i'length);  -- set i to 12</span></a>
<a name="35"><span class="lineNum">      35 </span><span class="lineCov">          6 :         elsif rising_edge(clk) then</span></a>
<a name="36"><span class="lineNum">      36 </span><span class="lineCov">          8 :             i &lt;= p_i;</span></a>
<a name="37"><span class="lineNum">      37 </span>            :         end if;</a>
<a name="38"><span class="lineNum">      38 </span>            :     end process;</a>
<a name="39"><span class="lineNum">      39 </span>            : </a>
<a name="40"><span class="lineNum">      40 </span>            :     -- i controls the interpolation:</a>
<a name="41"><span class="lineNum">      41 </span>            :     -- when i = 12 we are idle</a>
<a name="42"><span class="lineNum">      42 </span>            :     -- if we receive a valid input, we go to i = 0</a>
<a name="43"><span class="lineNum">      43 </span>            :     -- when i is between 0 and 11, interpolate</a>
<a name="44"><span class="lineNum">      44 </span>            :     -- afterwards go again to i = 12</a>
<a name="45"><span class="lineNum">      45 </span><span class="lineCov">        102 :     comb: process(inf, sup, valid, i)</span></a>
<a name="46"><span class="lineNum">      46 </span>            :     begin</a>
<a name="47"><span class="lineNum">      47 </span><span class="lineCov">          4 :         if (i &lt; 0) or (i &gt; 11) then  -- Anything that is not between 0 and 11: idle</span></a>
<a name="48"><span class="lineNum">      48 </span><span class="lineNoCov">          0 :             estim_valid &lt;= '0';</span></a>
<a name="49"><span class="lineNum">      49 </span><span class="lineNoCov">          0 :             if valid = '1' then</span></a>
<a name="50"><span class="lineNum">      50 </span><span class="lineNoCov">          0 :                 p_i &lt;= to_signed(0, p_i'length);</span></a>
<a name="51"><span class="lineNum">      51 </span>            :             else</a>
<a name="52"><span class="lineNum">      52 </span><span class="lineNoCov">          0 :                 p_i &lt;= to_signed(12,p_i'length);</span></a>
<a name="53"><span class="lineNum">      53 </span>            :             end if;</a>
<a name="54"><span class="lineNum">      54 </span>            :         else                         -- Between 0 and 11: interpolate</a>
<a name="55"><span class="lineNum">      55 </span><span class="lineCov">         12 :             p_i &lt;= i + 1;</span></a>
<a name="56"><span class="lineNum">      56 </span><span class="lineCov">          2 :             estim_valid &lt;= '1';</span></a>
<a name="57"><span class="lineNum">      57 </span>            :         end if;</a>
<a name="58"><span class="lineNum">      58 </span>            :     end process;</a>
<a name="59"><span class="lineNum">      59 </span>            : </a>
<a name="60"><span class="lineNum">      60 </span><span class="lineCov">        114 :     estim_aux.re &lt;= inf.re*(12-i) + sup.re*i;</span></a>
<a name="61"><span class="lineNum">      61 </span><span class="lineCov">        114 :     estim_aux.im &lt;= inf.im*(12-i) + sup.im*i;</span></a>
<a name="62"><span class="lineNum">      62 </span>            : </a>
<a name="63"><span class="lineNum">      63 </span>            :     -- Discard the most significant bit since it doesn't contain any</a>
<a name="64"><span class="lineNum">      64 </span>            :     -- information (it is redundant with bit 13), and keep the 10 most</a>
<a name="65"><span class="lineNum">      65 </span>            :     -- significant of the rest</a>
<a name="66"><span class="lineNum">      66 </span><span class="lineCov">        126 :     estim.re &lt;= estim_aux.re(13 downto 4);</span></a>
<a name="67"><span class="lineNum">      67 </span><span class="lineCov">        126 :     estim.im &lt;= estim_aux.im(13 downto 4);</span></a>
<a name="68"><span class="lineNum">      68 </span>            : </a>
<a name="69"><span class="lineNum">      69 </span>            :     -- Firewall assertions: assure that our module is being used correctly</a>
<a name="70"><span class="lineNum">      70 </span>            :     --</a>
<a name="71"><span class="lineNum">      71 </span>            :     -- What can go wrong?</a>
<a name="72"><span class="lineNum">      72 </span>            :     --</a>
<a name="73"><span class="lineNum">      73 </span>            :     -- 1) Valid cannot be asserted while the interpolator is busy</a>
<a name="74"><span class="lineNum">      74 </span>            :     --</a>
<a name="75"><span class="lineNum">      75 </span>            :     -- 2) Input data cannot change while the interpolator is busy</a>
<a name="76"><span class="lineNum">      76 </span>            :     -- (the interpolator is busy if 0 &lt;= i &lt;= 11)</a>
<a name="77"><span class="lineNum">      77 </span>            :     --</a>
<a name="78"><span class="lineNum">      78 </span>            :     -- An interesting idea here would be to define a procedure in</a>
<a name="79"><span class="lineNum">      79 </span>            :     -- edc_common.vhd called &quot;fail_in_N_cycles&quot;, which would</a>
<a name="80"><span class="lineNum">      80 </span>            :     -- wait N clock cycles before stopping the simulation</a>
<a name="81"><span class="lineNum">      81 </span><span class="lineCov">         82 :     firewall_assertions: process (clk)</span></a>
<a name="82"><span class="lineNum">      82 </span>            :     begin</a>
<a name="83"><span class="lineNum">      83 </span><span class="lineCov">          6 :         if falling_edge(clk) then</span></a>
<a name="84"><span class="lineNum">      84 </span><span class="lineCov">         42 :             firewall_sup &lt;= sup;</span></a>
<a name="85"><span class="lineNum">      85 </span><span class="lineCov">         42 :             firewall_inf &lt;= inf;</span></a>
<a name="86"><span class="lineNum">      86 </span><span class="lineCov">          2 :             if (i &gt;= 0) and (i &lt;= 11) then</span></a>
<a name="87"><span class="lineNum">      87 </span><span class="lineNoCov">          0 :                 if valid = '1' then</span></a>
<a name="88"><span class="lineNum">      88 </span><span class="lineNoCov">          0 :                     report &quot;valid asserted while interpolator busy, data will be lost&quot;</span></a>
<a name="89"><span class="lineNum">      89 </span>            :                     severity failure;</a>
<a name="90"><span class="lineNum">      90 </span>            :                 end if;</a>
<a name="91"><span class="lineNum">      91 </span><span class="lineNoCov">          0 :                 if (inf /= firewall_inf) or (sup /= firewall_sup) then</span></a>
<a name="92"><span class="lineNum">      92 </span><span class="lineCov">          2 :                     report &quot;data changed while interpolator busy, interpolation will be wrong&quot;</span></a>
<a name="93"><span class="lineNum">      93 </span>            :                     severity failure;</a>
<a name="94"><span class="lineNum">      94 </span>            :                 end if;</a>
<a name="95"><span class="lineNum">      95 </span>            :             end if;</a>
<a name="96"><span class="lineNum">      96 </span>            :         end if;</a>
<a name="97"><span class="lineNum">      97 </span>            :     end process;</a>
<a name="98"><span class="lineNum">      98 </span>            : </a>
<a name="99"><span class="lineNum">      99 </span>            : end two_processes;</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
